/*
  ab * cd ̌ʁAabcd 0xXXXXXXXXłf[^10TB

   bd mul22 ---> A
  ad0 mul12 ---> B
  cb0 mul21 ---> C
 ac00 mul11 ---> D
      addAB ---> E
      addCD ---> F
      addEF --->
      check

  RpC@Fgcc -lpthread -DTHREAD=8 -DJOB_SIZE=256 -o Program_2 Source_Program_2.c
          THREADFXbh̎w
        JOB_SIZEF1Wũf[^w
  
*/
#include <stdio.h>
#include <pthread.h>
#define PATTERN  (0x0ABCDEF00)	// 6  
#define COUNT    (10)
static struct {int a,b;} found[COUNT];
static volatile unsigned int    count=COUNT;
static unsigned int    job_data[(0x10000/JOB_SIZE)+1];
static unsigned int    job_index;
static unsigned int    job_counts;
static unsigned int    job_size=JOB_SIZE;
static pthread_mutex_t mutex_count;
static pthread_mutex_t mutex_job;

static int mul11(int a, int c) { return (a * c) << 16; }
static int mul12(int a, int d) { return (a * d) << 8; }
static int mul21(int c, int b) { return (c * b) << 8; }
static int mul22(int b, int d) { return (b * d); }
static int addAB(int A, int B) { return (A + B); }
static int addCD(int C, int D) { return (C + D); }
static int addEF(int E, int F) { return (E + F); }
static int check(int X) { return !(X ^ PATTERN); }

unsigned int *get_job()
{
  int index;

  if ( pthread_mutex_lock(&mutex_job) )
      printf(" Mutex Lock Error (%d)\n",__LINE__);
  if (job_index + 1 == job_counts)
  {
    if ( pthread_mutex_unlock(&mutex_job) )
	printf(" Mutex Unlock Error (%d)\n",__LINE__);
    return NULL;
  }
  index = job_index++;
  if ( pthread_mutex_unlock(&mutex_job) )
      printf(" Mutex Unlock Error (%d)\n",__LINE__);
  return &job_data[index];
}

void sub(unsigned int i,unsigned int job_count)
{
  int a,b,c,d,A,B,C,D,E,F,X;
  unsigned int j;

  do
  {
    for ( j = 0 ; count && j <= 0xFFFF ; j++ )
    {
      a = i >> 8;	// 1oCgo(ӏ)
      b = i & 0xFF;	// 1oCgo(Ӊ)
      c = j >> 8;	// 1oCgo(Eӏ)
      d = j & 0xFF;	// 1oCgo(EӉ)
      D = mul22(b,d);	// ZP(ʁ~)
      B = mul12(a,d);	// ZQ(ʁ~) << 8
      C = mul21(c,b);	// ZR(ʁ~) << 8
      A = mul11(a,c);	// ZS(ʁ~) << 16
      F = addCD(C,D);	// ZP(ZP{ZR)
      E = addAB(A,B);	// ZQ(ZQ{ZS)
      X = addEF(E,F);	// ZR(ZP{ZQ)
      if( check(X) )
      {
        if ( pthread_mutex_lock(&mutex_count) )
            printf(" Mutex Lock Error (%d)\n",__LINE__);
	count--;
	found[count].a = i;
	found[count].b = j;
	if ( pthread_mutex_unlock(&mutex_count) )
            printf(" Mutex Unlock Error (%d)\n",__LINE__);
	printf("%8.8X = %4.4X * %4.4X\n",X,i,j);
      }
    }
    i++;
  } while ( --job_count );
  return;
}

void thread_job(void *arg)
{
  unsigned int *jobp;

  while ( (jobp = get_job()) != NULL )
    sub(*jobp,*((unsigned int *)arg));
}

void main(void)
{
  unsigned int i,j;
  pthread_t    jobs[THREAD]; 

  for ( i = j = 0 ; j <= 0xFFFF ; j+=JOB_SIZE )
    job_data[i++] = j;
  job_counts = i;
  job_index = 0;
  pthread_mutex_init(&mutex_job, NULL);
  pthread_mutex_init(&mutex_count, NULL);

  for ( i = 0 ; i < THREAD ; i++ )
  {
    if ( pthread_create(&jobs[i], NULL, (void *)thread_job, (void *)&job_size) )
        printf(" Thread Create Error (%d)\n",__LINE__);
  }
  
  for ( i = 0; i < THREAD ; i++ ) 
    pthread_join(jobs[i], NULL);
  return;
}
